SystemOrganization addCategory: #'CS528su13AES-HW4'!

!Number methodsFor: '*CS528su13AES-HW4' stamp: 'ShruthiSudhanva 6/11/2013 17:20'!
elephants
	^NumberWithUnits value: self unit:#elephants. ! !

!Number methodsFor: '*CS528su13AES-HW4' stamp: 'ShruthiSudhanva 6/16/2013 13:47'!
grams
	^NumberWithUnits value: self unit: #grams. ! !

!Number methodsFor: '*CS528su13AES-HW4' stamp: 'ShruthiSudhanva 6/11/2013 17:19'!
meters
	^NumberWithUnits value: self unit: #meters. ! !

!Number methodsFor: '*CS528su13AES-HW4' stamp: 'ShruthiSudhanva 6/11/2013 17:13'!
sec
	^NumberWithUnits value: self unit: #seconds.! !

Number subclass: #NumberWithUnits
	instanceVariableNames: 'value units'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13AES-HW4'!

!NumberWithUnits class methodsFor: 'as yet unclassified' stamp: 'ShruthiSudhanva 6/11/2013 15:57'!
value: aNumber unit: aUnit
	^self new value: aNumber unit: aUnit.! !

!NumberWithUnits methodsFor: 'arithmetic' stamp: 'ShruthiSudhanva 6/19/2013 13:10'!
* aValue
	| result |
	result := NumberWithUnits new.
	result value: value * aValue value.
	result units: (units multiplyUnits: aValue units).
	^result.
	! !

!NumberWithUnits methodsFor: 'arithmetic' stamp: 'ShruthiSudhanva 6/19/2013 13:07'!
+ aValue
	| result |
	result := NumberWithUnits new.
	units = aValue units  
	ifTrue: [ 
		result value: value + aValue value.
		result units: units
			]
	ifFalse: [ self error: 'Cannot add different types' ].
	^result.! !

!NumberWithUnits methodsFor: 'arithmetic' stamp: 'ShruthiSudhanva 6/19/2013 13:08'!
- aValue
	| result |
	result := NumberWithUnits new.
	units = aValue units  
	ifTrue: [ 
		result value: value - aValue value.
		result units: units
			]
	ifFalse: [ self error: 'Cannot add different types' ].
	^result.! !

!NumberWithUnits methodsFor: 'arithmetic' stamp: 'ShruthiSudhanva 6/19/2013 13:11'!
/ aValue 
	| result |
	result := NumberWithUnits new.
	result value: value / aValue value.
	result units: (units divideUnits: aValue units).
	^result.! !

!NumberWithUnits methodsFor: 'comparing' stamp: 'ShruthiSudhanva 6/14/2013 19:16'!
< aValue
"provided units are the same"
	units = aValue units 
	ifTrue:[
		^(value < aValue value)]
	ifFalse:[
		^false
	] ! !

!NumberWithUnits methodsFor: 'comparing' stamp: 'ShruthiSudhanva 6/14/2013 19:14'!
= aValue
	(value = aValue value) ifTrue: [ 
		(units = aValue units) ifTrue: [ ^true ]
		 ] .
	 ^false. ! !

!NumberWithUnits methodsFor: 'converting' stamp: 'ShruthiSudhanva 6/11/2013 15:49'!
adaptToFraction: rcvr andSend: selector! !

!NumberWithUnits methodsFor: 'converting' stamp: 'ShruthiSudhanva 6/11/2013 15:50'!
adaptToInteger: rcvr andSend: selector! !

!NumberWithUnits methodsFor: 'comparing' stamp: 'ShruthiSudhanva 6/11/2013 15:55'!
hash! !

!NumberWithUnits methodsFor: 'testing' stamp: 'ShruthiSudhanva 6/14/2013 19:08'!
isNumberWithUnits
	^true.! !

!NumberWithUnits methodsFor: 'printing' stamp: 'ShruthiSudhanva 6/18/2013 17:08'!
printOn: aStream base: base

	value printOn: aStream base: base.
	aStream nextPut: Character space.
	units printOn: aStream .
! !

!NumberWithUnits methodsFor: 'printing' stamp: 'ShruthiSudhanva 6/11/2013 15:56'!
storeOn: arg1 base: arg2! !

!NumberWithUnits methodsFor: 'accessing' stamp: 'ShruthiSudhanva 6/11/2013 21:11'!
units
	^units! !

!NumberWithUnits methodsFor: 'accessing' stamp: 'ShruthiSudhanva 6/19/2013 13:06'!
units: aUnit
	units := aUnit.! !

!NumberWithUnits methodsFor: 'accessing' stamp: 'ShruthiSudhanva 6/12/2013 11:54'!
value
	^value ! !

!NumberWithUnits methodsFor: 'accessing' stamp: 'ShruthiSudhanva 6/19/2013 13:06'!
value: aValue
	value := aValue.! !

!NumberWithUnits methodsFor: 'initialize' stamp: 'ShruthiSudhanva 6/18/2013 16:28'!
value: aValue unit: aUnit
	super initialize.
	units := ComplexUnits new.
	units add: aUnit.
	
	(aValue isNumberWithUnits) ifTrue: [
		value := aValue value.
		units := units multiplyUnits: aValue units.
		]
	ifFalse:[
	value := aValue].

	^self.
! !

!Object methodsFor: '*CS528su13AES-HW4' stamp: 'ShruthiSudhanva 6/18/2013 16:25'!
equalToComplexUnits: aUnit
	^false.! !

!Object methodsFor: '*CS528su13AES-HW4' stamp: 'ShruthiSudhanva 6/18/2013 16:20'!
equalToGrams: aUnit
	^false.! !

!Object methodsFor: '*CS528su13AES-HW4' stamp: 'ShruthiSudhanva 6/18/2013 16:20'!
equalToSeconds: aUnit
	^false.! !

!Object methodsFor: '*CS528su13AES-HW4' stamp: 'ShruthiSudhanva 6/14/2013 19:10'!
isNumberWithUnits
	^false.! !

Object subclass: #Units
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13AES-HW4'!

Units subclass: #ComplexUnits
	instanceVariableNames: 'dict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13AES-HW4'!

!ComplexUnits methodsFor: 'comparing' stamp: 'ShruthiSudhanva 6/18/2013 16:22'!
= aUnit 
	^aUnit equalToComplexUnits: self! !

!ComplexUnits methodsFor: 'initialize' stamp: 'ShruthiSudhanva 6/18/2013 17:26'!
add: aUnit
	aUnit = #grams ifTrue:
	[
		self dict at: Grams new put: 1.
	]
	ifFalse:
	[ 
		aUnit = #seconds ifTrue:
		[
			self dict at: Seconds new put:1. 
		]
		ifFalse:
		[ 
			self dict at:aUnit put:1.
		]
	]! !

!ComplexUnits methodsFor: 'private' stamp: 'ShruthiSudhanva 6/16/2013 13:55'!
at: symbol
	(dict includesKey:symbol) ifTrue: [^dict at:symbol ] ifFalse:[^0].! !

!ComplexUnits methodsFor: 'private' stamp: 'ShruthiSudhanva 6/16/2013 13:55'!
at: symbol put: value 
	dict at:symbol put:value! !

!ComplexUnits methodsFor: 'accessing' stamp: 'ShruthiSudhanva 6/16/2013 13:55'!
dict
	^dict.! !

!ComplexUnits methodsFor: 'arithmetic' stamp: 'ShruthiSudhanva 6/18/2013 17:24'!
divideUnits: aUnit
	| allSymbols resultUnit|
	allSymbols := Set newFrom: (self dict keys , aUnit dict keys ).
	resultUnit := ComplexUnits new.
	allSymbols do:[:symbol | resultUnit at:symbol put: (self at:symbol) - (aUnit at:symbol)].
	
	^resultUnit.
	
	"aDictionary  keysAndValuesDo: [:key :value |
		(dict includesKey: key) ifTrue: [  
		dict at: key put: (dict  at:key) - value ]
		ifFalse:[
			dict at:key put: 0-value
			]
		].
	^self."! !

!ComplexUnits methodsFor: 'comparing' stamp: 'ShruthiSudhanva 6/18/2013 16:22'!
equalToComplexUnits: aUnit
	^dict = aUnit dict! !

!ComplexUnits methodsFor: 'comparing' stamp: 'ShruthiSudhanva 6/16/2013 13:55'!
hash! !

!ComplexUnits methodsFor: 'initialize' stamp: 'ShruthiSudhanva 6/16/2013 13:55'!
initialize 
	super initialize.
	dict := Dictionary new.
	^self.! !

!ComplexUnits methodsFor: 'arithmetic' stamp: 'ShruthiSudhanva 6/18/2013 17:24'!
multiplyUnits: aUnit
	| allSymbols resultUnit|
	allSymbols := Set newFrom: (self dict keys , aUnit dict keys ).
	resultUnit := ComplexUnits new.
	allSymbols do:[:symbol | resultUnit at:symbol put: (self at:symbol) + (aUnit at:symbol)].
	
	^resultUnit.! !

!ComplexUnits methodsFor: 'printing' stamp: 'ShruthiSudhanva 6/16/2013 13:55'!
printOn: aStream
"Try coverting them into a set and then select on it. Easier"

	| numerator denominator |
	
	numerator := dict associationsSelect: [ :assoc | assoc value >0 ].
	numerator keysAndValuesDo: [:key :value | self printOn: aStream times: value key: key ].

	
	denominator := dict associationsSelect: [ :assoc | assoc value <0 ].
	denominator ifNotEmpty:[aStream nextPut: $/].
	denominator keysAndValuesDo: [:key :value | self printOn: aStream times: 0-value key: key ].
	
	
	"
	dict keysAndValuesDo: [ :key :value | (value > 0)
				 ifTrue: [ self printOn: aStream times: value key: key 
					 ]].
			
	dict keysAndValuesDo: [ :key :value | (value < 0)
				ifTrue: [ aStream nextPut:$/.
					 self printOn: aStream times:( 0-value) key: key ]
				 ]."
! !

!ComplexUnits methodsFor: 'printing' stamp: 'ShruthiSudhanva 6/18/2013 17:10'!
printOn: aStream times: aValue key: aKey 
	aValue timesRepeat: [
						(aKey asString) printOn: aStream. 
						aStream nextPut: Character space.]! !

Units subclass: #Grams
	instanceVariableNames: ''
	classVariableNames: 'gramsInstance'
	poolDictionaries: ''
	category: 'CS528su13AES-HW4'!

!Grams class methodsFor: 'as yet unclassified' stamp: 'ShruthiSudhanva 6/18/2013 15:57'!
new
    gramsInstance isNil ifTrue: [gramsInstance := super new].
    ^ gramsInstance! !

!Grams methodsFor: 'comparing' stamp: 'ShruthiSudhanva 6/18/2013 16:14'!
= aUnit 
	^aUnit equalToGrams: self.! !

!Grams methodsFor: 'converting' stamp: 'ShruthiSudhanva 6/18/2013 17:09'!
asString
	^'grams'.! !

!Grams methodsFor: 'comparing' stamp: 'ShruthiSudhanva 6/18/2013 16:13'!
equalToGrams: aUnit
	^true.! !

Units subclass: #Seconds
	instanceVariableNames: ''
	classVariableNames: 'secondsInstance'
	poolDictionaries: ''
	category: 'CS528su13AES-HW4'!

!Seconds class methodsFor: 'as yet unclassified' stamp: 'ShruthiSudhanva 6/18/2013 16:00'!
new
	secondsInstance isNil ifTrue: [secondsInstance := super new].
    ^ secondsInstance! !

!Seconds methodsFor: 'comparing' stamp: 'ShruthiSudhanva 6/18/2013 16:15'!
=aUnit
	^aUnit equalToSeconds: self.! !

!Seconds methodsFor: 'converting' stamp: 'ShruthiSudhanva 6/18/2013 17:09'!
asString
	^'seconds'.! !

!Seconds methodsFor: 'comparing' stamp: 'ShruthiSudhanva 6/18/2013 16:16'!
equalToSeconds: aUnit 
	^true.! !

!Units methodsFor: 'comparing' stamp: 'ShruthiSudhanva 6/16/2013 13:56'!
= aUnit
	^self subclassResponsibility.! !

TestCase subclass: #HW4Tests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13AES-HW4'!

!HW4Tests methodsFor: 'as yet unclassified' stamp: 'ShruthiSudhanva 6/14/2013 19:28'!
testNumberWithUnitsAddNumbers
	| stream |
	stream := String new writeStream.
	(4 sec sec + 10.5 sec sec)  printOn: stream.
	self assert:  stream contents = '14.5 ''seconds'' ''seconds'' '.! !

!HW4Tests methodsFor: 'as yet unclassified' stamp: 'ShruthiSudhanva 6/14/2013 12:11'!
testNumberWithUnitsCompareNumbers
	| stream |
	stream := String new writeStream.
	(3 sec = 3 sec) printOn: stream.
	self assert: stream contents = 'true'.
	stream reset.
	(5 elephants = 3 sec) printOn: stream.
	self assert: stream contents = 'false'.
	stream reset.
	(4 meters < 5 meters) printOn: stream.
	self assert: stream contents = 'true'.
	stream reset.
	(4 meters > 5 meters) printOn: stream.
	self assert: stream contents = 'false'.! !

!HW4Tests methodsFor: 'as yet unclassified' stamp: 'ShruthiSudhanva 6/14/2013 19:35'!
testNumberWithUnitsDivideNumbers
	| stream |
	stream := String new writeStream.
	(8 sec elephants / 4 sec meters)  printOn: stream.
	self assert: stream contents = '2 ''elephants'' /''meters'' '.
	stream reset.
	(4 sec * 3 meters / 4 sec meters) printOn: stream.
	self assert: stream contents = '3 '.! !

!HW4Tests methodsFor: 'as yet unclassified' stamp: 'ShruthiSudhanva 6/18/2013 17:29'!
testNumberWithUnitsMultiplyNumbers
	| stream |
	stream := String new writeStream.
	(4 sec elephants * 10.5 sec meters)  printOn: stream.
	self assert: stream contents =  '42.0 ''elephants'' ''meters'' ''seconds'' ''seconds'' '.! !

!HW4Tests methodsFor: 'as yet unclassified' stamp: 'ShruthiSudhanva 6/13/2013 12:37'!
testNumberWithUnitsSingleUnit
	| stream |
	stream := String new writeStream.
	3 sec printOn: stream.
	self assert:  stream contents = '3 ''seconds'' '.! !

!HW4Tests methodsFor: 'as yet unclassified' stamp: 'ShruthiSudhanva 6/14/2013 19:28'!
testNumberWithUnitsSubtractNumbers
	| stream |
	stream := String new writeStream.
	(4 sec meters - 10.5 sec meters)  printOn: stream.
	self assert: stream contents = '-6.5 ''seconds'' ''meters'' '.! !
